#include "loadTGA.h"

int loadTGA(const char* filename, struct TGAImage* image)
{
	FILE* file;
	GLubyte header_BGR[12]={0,0,2,0,0,0,0,0,0,0,0,0};
	GLubyte header_GS[12]={0,1,1,0,0,0,1,24,0,0,0,0};
	GLubyte header_compare[12];
	GLubyte info[6]; // {width_h,width_l,height_h,height_l,bpp,...}
	GLubyte temp;
	unsigned int i;
	GLuint bytespp;
	int type;

	if ((file = fopen(filename,"rb"))==NULL) //file aperto?
		return 0;
	if ((fread(header_compare,sizeof(GLubyte),12,file)!=12)|| //header  lungo 12 bytes?
		((type=memcmp(header_BGR,header_compare,12*sizeof(GLubyte))!=0)&& //header=={0,0,2,0,0,0,0,0,0,0,0,0}?
		(memcmp(header_GS,header_compare,12*sizeof(GLubyte))!=0))||
		(fread(info,sizeof(GLubyte),6,file))!=6) //info  lumgo 6 bytes?
	{
		fclose(file);
		return 0;
	}
	image->width = 256*info[1]+info[0];
	image->height = 256*info[3]+info[2];
	image->bpp = info[4];
	if ((image->width<=0)||(image->height<=0)||
		((image->bpp!=32)&&(image->bpp!=24)&&(image->bpp!=16)&&(image->bpp!=8)))
	{
		free(image->data);
		fclose(file);
		return 0;
	}
	bytespp = image->bpp/8;
	image->size = image->width * image->height * bytespp;
	image->data = malloc(image->size*sizeof(GLubyte)); //memoria allocata per i dati
	if (type==0) //RGB
	{
		if ((image->data==NULL)||(fread(image->data,sizeof(GLubyte),image->size,file)!=image->size))
		{
			free(image->data);
			fclose(file);
			return 0;
		}
		for (i=0;i<image->size;i+=bytespp) // convert from GBR to RGB
			{
				temp = image->data[i];
				image->data[i] = image->data[i+2];
				image->data[i+2] = temp;
			}
			fclose(file);
			return 1;
	}
	else //color index
	{
		if ((image->data==NULL)||(fseek(file,3*256,SEEK_CUR)!=0)||
			(fread(image->data,sizeof(GLubyte),image->size,file)!=image->size))
		{
			free(image->data);
			fclose(file);
			return 0;
		}
		fclose(file);
		return 2;
	}
}